#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include "tastiera.h"
#include "colori.h"


#define MAXLIBVERSION	"1.53"

int (*CLIENT_MESSAGE)();		// Funzione di Chiusura

typedef enum {
	WINBG,WINFG,
	BUTTONBG,BUTTONFG,
	INPUTBG,INPUTFG,
	MENUBG,MENUFG,
	LISTBOXBG,LISTBOXFG
	} ColorInfo_Type;
struct ColorInfo
{
	unsigned int WinBg;
	unsigned int WinFg;

	unsigned int ButtonBg;
	unsigned int ButtonFg;

	unsigned int InputBg;
	unsigned int InputFg;

	unsigned int MenuBg;
	unsigned int MenuFg;

	unsigned int ListCmdBg;
	unsigned int ListCmdFg;

} ColorInfo;

typedef struct SignalInfo
{
	//
	int Tipo;
	int (*CallBack)();	
	void *data;		
	//
}SignalInfo;

typedef struct SignalHeaderInfo
{
	//
	void *Cmd; //struct CmdInfo *Cmd;

	int num_signals;
	SignalInfo ** signals;	

	struct SignalHeaderInfo *Prev;
	struct SignalHeaderInfo *Next;	
	//
}SignalHeaderInfo;

typedef enum { 
	MAIN, BORDO, AREA, LABEL, BUTTON, 
	MENU, MENU_ITEM, INPUT, LIST_BOX, COMBO_BOX,
	SCROLL,
	SCROLL_UP, SCROLL_DN, SCROLL_PGUP, SCROLL_PGDN, SCROLL_VCUR,
	SCROLL_SX, SCROLL_DX, SCROLL_PGSX, SCROLL_PGDX, SCROLL_HCUR, 
	} CmdInfo_Type;

typedef struct CmdInfo
{
	//
	// Tipo Finestra (vedi CmdInfo_Type)
	int Tipo;
	//
	// Nome (Opzionale)
	char * Name;
	//
	// Window	
	Window parent;
	Window win;
	//
	// Coordinate relative al parent
	int x;
	int y;
	int Width;
	int Height;
	//
	// Colori
	unsigned int Bg;
	unsigned int Fg;
	//
	// Parametri Generali
	short int Bordo;		// 0=None >0=Rilievo
	short int BUpDn;		// 0=Up   !0=Down
	short int MouseOver;		// 0=None !0=MouseOver
	short int Focus;		// 0=None !0=Focus
	short int Stato;		// 0=None !0=Selezionato
	short int Attivo;		// 0=None !0=Attivo
	short int Lock;			// 0=None !0=Locked
	//
	short int IsButton;		// 0=None !0=Buttoned
	//
	// Parametri Scroll
	short int scroll_tipo;		// 0=None
					// 1=Verticale
					// 2=Orizzontale
					// 3=Verticale+Orizzontale
	struct CmdInfo * scrollv;	// ptr Cmd Tipo SCROLL V 
	struct CmdInfo * scrollh;	// ptr Cmd Tipo SCROLL H 
	int scroll_x;			// 0=Origin
	int scroll_y;			// 0=Origin
	int scroll_max_x;		//
	int scroll_max_y;		//
	//
	// Font da utilizzare
	//
	XFontStruct *Font;
	//
	// Scritta da Visualizzare
	char * Label;
	//
	// Pixmap (opzionale)
	Pixmap pixmap;
	unsigned int bitmap_width;
	unsigned int bitmap_height;
	//
	// XImage (opzionale)
	XImage *ximage;
	unsigned int ximage_width;
	unsigned int ximage_height;
	//
	// Puntatore ad Eventi 
	struct SignalHeaderInfo *signal;
	//
	// Puntatore alla corrente lista
	struct CmdInfo * Prev;
	struct CmdInfo * Next;
	//
}CmdInfo ;


typedef struct FontInfo
{
	char * FontName;

	XFontStruct *Font;

	struct FontInfo *Prev;
	struct FontInfo *Next;	

}FontInfo;

typedef struct MenuInfo
{

	Window win;

	char * Buff;
	
	int NumeroItem;
	int MaxLenItem;

	Window win_items;
	struct MenuItemInfo *PrimoItem;
	struct MenuItemInfo *CorrenteItem;
	struct MenuItemInfo *UltimoItem;
	
	struct MenuInfo *Prev;
	struct MenuInfo *Next;
       	
}MenuInfo;

typedef struct MenuItemInfo
{
	Window win;

	int Tipo;

	char * Buff;

	int (*Funz)();

	struct MenuItemInfo *Prev;
	struct MenuItemInfo *Next;	

}MenuItemInfo;

typedef struct ListCmdInfo
{

	CmdInfo *CmdPar;   // Comando Parent
			   //
	CmdInfo *CmdOpen;  // Comando Bottone
			   // Per la ListBox  == NULL
			   // per la ComboBox == bottone
			   //
	CmdInfo *CmdInput; // Comando Input
			   // Per la ListBox  == NULL
			   // per la ComboBox == input
			   //
	int NumeroItem;    // Quantita'
	int MaxLenItem;    // Dimesione Item piu' lungo
			   //
	int Width;	   // Larghezza
	int Height;        // Altezza
			   //
	char * Name;	   // ??? Da Togliere ???
	Window win_items;  // Finestra items
			   //
	// Puntatore a Funzione (Opzionale?!)
	int (*Funz)();	   // Usata da ComboBox
	//
	// Puntatore ad Eventi 
	struct SignalHeaderInfo *signal;

			   //
	struct ListCmdItemInfo *PrimoItem;	// ptr alle liste
	struct ListCmdItemInfo *CorrenteItem; // relative degli
	struct ListCmdItemInfo *UltimoItem;	// items
						//
	struct ListCmdInfo *Prev;		//
	struct ListCmdInfo *Next;		//

}ListCmdInfo;

typedef struct ListCmdItemInfo
{
	CmdInfo *Cmd;	// Comando Aperto
			//
	int Tipo;	// CmdInfo_Type
			//
	char * Buff;	//
			//
	int (*Funz)();	//

	struct ListCmdItemInfo *Prev;
	struct ListCmdItemInfo *Next;	

}ListCmdItemInfo;

typedef struct Timer
{
	int (*CallBack)();	// La Funzione
	void *data;		// Il Parametro

	struct timeval START;	// Tempo Avvio
	struct timeval   TMP;	// Tempo Provvisiorio
				//
	int 		  STOP;	// Stop 
	long int INTERVAL;		// Intervallo

	struct Timer * Prev;
	struct Timer * Next;
	
} Timer;

// attualemnte in files.c
char *RTrim (char *stringa);
char *Instr (char *s1,char *s2);

// segnali.c
void FreeSignal (CmdInfo *Cmd);
void FreeAllSignal();
SignalInfo *SignalSearch (SignalHeaderInfo *SignalHead,int Tipo);
void SetSignalCallBack (void *Cmd,int Tipo,int (*CallBack)(),void *data);
int SignalExecCallBack(CmdInfo *Cmd,int Tipo);

// init.c
Display * ApreDisplay ();
void ChiudeDisplay ();
Display * GetDisplay ();
int GetDepth ();
int GetNumScreen ();
int GetDisplayWidth ();
int GetDisplayHeight ();
int InitFinestre (int argc, char **argv);
int EndFinestre ();

// color.c
unsigned int SetColor (int Where,int colore);
unsigned int GetColor (int Where);
void ChangeColor (CmdInfo *cmd);
int LightColor(unsigned int colore);
int SmallColor(unsigned int colore);
int DarkColor(unsigned int colore);

// font.c
void FreeFont (FontInfo *font);
void FreeAllFont ();
XFontStruct * ApreFont (char *Fontname);
XFontStruct * CorrenteFont ();
int WidthFont ();
int HeightFont ();
void xSetCmdFont (CmdInfo *cmd,char *Fontname);

// print.c	
CmdInfo * Print (CmdInfo *comando,int x,int y,char *Buff);
CmdInfo * PrintCenter (CmdInfo *comando,int y,char *Buff);
void MapFlush (CmdInfo *cmd);
void PrintFlush (CmdInfo *cmd);
int Cursore (int Set, int Visibile,int posx,Window win);
int PosizioneCursore (int Mode,int Posizione);
void ComandoRilievo(CmdInfo *comando);

// finestre.c
CmdInfo * PrimoComando (int Mode, CmdInfo *comando);
CmdInfo * UltimoComando (int Mode, CmdInfo *comando);
CmdInfo * ApreFinestra (char *Titolo,int x, int y, int larghezza, int altezza);
CmdInfo * ApreFinestraCentrale (char *Titolo, int larghezza, int altezza);
CmdInfo * ApreFinestraFullScreen (char *Titolo);
CmdInfo * ApreArea (CmdInfo *comando,int x,int y, int larghezza, int altezza, int colorbg, int colorfg, int Bordo);
CmdInfo * ApreBottone (CmdInfo *parent,int x, int y, int larghezza, int altezza, char *Buff, int (*Funz)());
CmdInfo * ApreInput (CmdInfo *parent, int x, int y, char *Buff, int Len,int Size);
int ChiudeFinestra (Window win);

// comandi.c
CmdInfo * ApreComando (int Tipo, CmdInfo * cmd_parent, int x, int y, int Width , int Height, unsigned int colorbg, unsigned int colorfg, int Bordo, char *Descr, int (*Funz)());
int ComandoAccesoSpento (int Focus,Window win);
void FreeCom (CmdInfo *com);
void FreeSubCom (Window win);
void xFreeCmd (CmdInfo *com);
void xFreeSubCmd (CmdInfo *com);
void ChiudeComando (CmdInfo *com);
int IsComando (CmdInfo *cmd);
CmdInfo * CercaComando (Window win);
CmdInfo * CercaNomeComando (char *Name);
void AddNomeComando (CmdInfo *comando,char *Name);
void CambiaLabel (char *Name,char *NewLabel);
void CambiaTesto (CmdInfo *db,char *NewLabel);
CmdInfo * GetPrevTopLevelWindow ();
void DisableTopLevelWindow (CmdInfo *comando);
void EnableTopLevelWindow (CmdInfo *comando);
CmdInfo * Button (CmdInfo * cmd_parent,	int x, int y, char *Descr, int (*Funz)());

// errori.c
void FatalError(char *msg, ...);

// menu.c
MenuInfo * PrimoMenu (MenuInfo *Menu);
MenuInfo * UltimoMenu (MenuInfo *Menu);
MenuInfo * CercaMenuInfo (Window win);
void Menu (CmdInfo *finestra);
void ApreMenu (Window win);
void ChiudeMenu (Window win);
MenuInfo * AddMenu (char *Buff);
void AddItemMenu (char *Buff,int (*Funz)());
void MenuFree ();

// input.c
int IsShift (int State);
int IsCtrl  (int State);
int IsAlt (int State);
int InputKey (int State, char KeyCode, char Key);

// eventi.c
void SetClientMessage (int (*Funz)());
int Eventi (CmdInfo * comando);
CmdInfo * UltimoComandoSelezionato (int Mode, CmdInfo *cmd);

// timer.c
void GetCurrentTime( struct timeval *tv);
int timeval_subtract (struct timeval *result, struct timeval *x, struct timeval *y);
Timer *NewTimer ();
void FreeTimer (Timer *t);
void FreeAllTimer ();
Timer *SetTimerCallBack (int (*Funz)(),void *data,long int interval);
void TimerStart (Timer *t);
struct timeval TimerWatch (Timer *t);
struct timeval TimerStop (Timer *t);
int TimerLook ();

// listcmd.c
ListCmdInfo * PrimaListCmd (int Mode,ListCmdInfo *ListCmd);
ListCmdInfo * UltimaListCmd (int Mode,ListCmdInfo *ListCmd);
void FreeListCmdItem (ListCmdInfo *ListCmd, ListCmdItemInfo *Item);
void FreeListCmd (ListCmdInfo *ListCmd);
void FreeUnusedListCmd ();
void AddItemListCmd (ListCmdInfo *ListCmd,int Tipo, char *Buff,int (*Funz)());
ListCmdInfo * AddListCmd (char *Name,int (*Funz)());
int IsListCmd (ListCmdInfo * lista);
ListCmdInfo * CercaListCmdName (char *Name);
ListCmdInfo * CercaListCmdInfo (Window win);
ListCmdInfo * CercaListCmdOpen (CmdInfo * cmd);

ListCmdItemInfo * CercaListCmdItemInfo (ListCmdInfo *ListCmd, Window win);

// scroll.c
int HandleScroll (int Mode,XEvent event);
int WheelScroll (CmdInfo *comando,unsigned int Button);
int ScrollingPage (CmdInfo *comando);
int ScrollingArea (CmdInfo *comando,int Cols,int Rows);
int xScrollBar (CmdInfo *finestra,int Tipo);

// listbox.c
int ListBoxSelectedItem (CmdInfo *comando);
void xListBox (CmdInfo *finestra,ListCmdInfo *ListCmd, int x, int y, int larghezza, int altezza);
int xClearAllListBoxItem (ListCmdInfo *ViewComment);
void xListBoxRefresh (ListCmdInfo *ListCmd);

// combobox.c
void xComboBox (CmdInfo *finestra,ListCmdInfo *ListCmd, int x, int y, int altezza, char *input, int Len,int Size);
int ComboBoxSelectedItem (CmdInfo *comando);

// alert.c
int Alert (char *Messaggio, ...);

// files.c
char * xFiles (char *CurDir,...);
char * PathEsecuzione (char *eseguibile);
char * FullPath (char *file);

// viewfile.c
char *TabulazioniRiga (char *riga_in);
int xViewFile (char *filename,char *titolo, int LlWin, int HhWin);

// imgjpeg.c
int ImmagineJPG (char *file,CmdInfo *Cmnd);

// util.c
Window Select_Window();

// debug.c
void debug_TipoComando (int Tipo);
void debug_Comando (CmdInfo *Comando);
void debug_all ();
void debug_listbox ();
int debug_dettaglio (Window win);

