/*

 Gestione simmetria
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

void GetShape_SudokuBoard (unsigned int newboard[])
{
	int x,y;
	for (y=0;y<SUD_TAB;y++)
	{
		newboard[y]=0;
		for (x=0;x<SUD_TAB;x++)
		{
			if (!(SUD_BUF[y][x] & CANDI_MSK))
				newboard[y] |= (1 << x);
		}
	}

}

void Rotate_90_SudokuBoard (unsigned int board[],unsigned int newboard[])
{
	int x,y;
	for (y=0;y<SUD_TAB;y++)
	{
		newboard[y]=0;
		for (x=0;x<SUD_TAB;x++)
		{
			if (board[x] & (1<<y))
				newboard[y]|=(1 << (SUD_TAB-x-1));
		}
	}

}

void Reflection_SudokuBoard (unsigned int board[],unsigned int newboard[])
{
	int x,y;
	
	for (y=0;y<SUD_TAB;y++)
	{
		newboard[y]=0;
		for (x=0;x<SUD_TAB;x++)
		{
			if (board[y] & (1<<x))
				newboard[y]|=(1 << ((SUD_TAB-x)-1));
		}
	}
}

int IsSymmetric ()
{
	short int Type=0x3F; // (11111)
	/*
	Returned Value
	bit 0= Diagonal or anti-diagonal reflection
	bit 1= Horizzontal or Vertical  reflection
	bit 2= 180^ rotational symmetry
	bit 3= Diagonal and anti-diagonal reflection
	bit 4= Horizzontal and Vertical reflection
	bit 5= Full rotational symmetry
	All bit Set = Full dihedral symmetry
	No bit Set  = No symmetry
	*/
	
	int y;

	unsigned int 
		board[SUD_TAB],
		a[SUD_TAB],
		a2[SUD_TAB],
		a3[SUD_TAB],
		e[SUD_TAB],
		b[SUD_TAB],
		ba[SUD_TAB],
		ba2[SUD_TAB],
		ba3[SUD_TAB];


	GetShape_SudokuBoard (board);

	Rotate_90_SudokuBoard (board,a);	// 90 clockwise rotation
	Rotate_90_SudokuBoard (a,a2);		// 180 rotation
	Rotate_90_SudokuBoard (a2,a3); 		// 270 clockwise rotation
	Rotate_90_SudokuBoard (a3,e); 		// 360 clockwise rotation
	
	Reflection_SudokuBoard(board,b);	// Reflect in vert.axis
	Rotate_90_SudokuBoard (b,ba);		// Reflect in anti-diagonal
	Rotate_90_SudokuBoard (ba,ba2);		// Reflect in oriz.axis
	Rotate_90_SudokuBoard (ba2,ba3);	// Reflect in main diagonal

	for (y=0;y<SUD_TAB;y++)
	{
		if (e[y]!=a[y])  			Type &= ~(1 << (5));
		if (e[y]!=b[y])  			Type &= ~(1 << (4));
		if (e[y]!=ba[y]) 			Type &= ~(1 << (3));
		if (e[y]!=a2[y]) 			Type &= ~(1 << (2));
		if ((e[y]!=b[y])  || (e[y]!=ba2[y])) 	Type &= ~(1 << (1));
		if ((e[y]!=ba[y]) || (e[y]!=ba3[y])) 	Type &= ~(1 << (0));
	
		/*
		printf ("(%4d) a=%4d a2=%4d a3=%4d e=%4d -- b=%4d ba=%4d ba2=%4d ba3=%4d\n",
			board[y],a[y],a2[y],a3[y],e[y],b[y],ba[y],ba2[y],ba3[y]);
		*/
	}
	//printf ("Type %d\n",Type);
	return (Type);

}



